#include "mbed.h"
#include "filter1.h"
#include "filter2.h"

#include <stdlib.h> 
#include <string.h> 
 
DigitalOut led(LED_RED);
DigitalOut led1(LED_GREEN);
DigitalOut led3(LED_BLUE);

AnalogIn   ain(A5);
AnalogIn   ain1(A0);

Serial pc(USBTX, USBRX);
Timer t;

int compare (const void * a, const void * b);

float filter1_coefficients[20] = 
{
    0.031204475248076256, -0.019329715001997424, 0.031204475248076256, 1.839831602721114, -0.8605346265660301,// b0, b1, b2, a1, a2
    0.0625, -0.10115684282739926, 0.0625, 1.9459362746567421, -0.9598757181862136,// b0, b1, b2, a1, a2
    2, -3.9986129528091103, 1.9999999999999996, 1.7179861756068087, -0.7750460108721245,// b0, b1, b2, a1, a2
    1, -1.9965354515394274, 1.0000000000000002, 1.80335206087715, -0.8981414870173532// b0, b1, b2, a1, a2

};

float filter2_coefficients[20] = 
{
    0.014489882615245801, 0.02143588822207229, 0.014489882615245798, 1.9038717583185607, -0.906769336352675,// b0, b1, b2, a1, a2
    0.03125, 0.004824824964616673, 0.03125000000000001, 1.9633347481552883, -0.9662716994952747,// b0, b1, b2, a1, a2
    8, -15.999243804019745, 8.000000000000002, 0.785862148524004, -0.1978770593795492,// b0, b1, b2, a1, a2
    8, -15.995671171667441, 7.999999999999999, 1.0516221674376618, -0.615130751516217// b0, b1, b2, a1, a2

};

const int size = 1;

const int inputBufferSize = 1;           // Length of the input buffer

const int outputBufferSize = 1;         // Length of the output buffer

float inputBuffer[inputBufferSize], outputBuffer[outputBufferSize]; // Allocate an input and output buffer     
float inputBuffer1[inputBufferSize], outputBuffer1[outputBufferSize]; // Allocate an input and output buffer 


int main()
{

int nProcessedSamples;                                                        
float samples[size];
float cas1, cas2, cas[2];
int c1=0, f=0, f1=0,c2=0, c3=0, c4=0, k=0, c5=0;
int okno1=21;
float P[okno1];
float nprh=0;
float mmx;
float RRu;
float maxima[150];
float obal=0;
float RR[3];
float prah=0;
int ff1=0, ff2=0;
float BPM=0;
float NormalBPM=0, Normaldech=0;
float ccas1, ccas2, ccas;
float samples1[size];
float filtvzor;
     
pc.baud(115200);
led1=1;
led=0;
led3=1;

filter1Type *filter = filter1_create();  
filter2Type *filter2 = filter2_create();  

//Smyčka pro učení práhu detekce R vln
for (int i=0;i<10000;i++)
{      
    samples[0] = ain.read_u16();    //přečtení vzorku
    nProcessedSamples = filter1_filterBlock( filter, samples, outputBuffer, inputBufferSize );  //filtrování vzorku
  
    P[c1]=outputBuffer[0];
    c1++;
    if (c1==okno1 || f==1)  //začátek výpočtu obálky
    {
        f=1;
        c1=okno1-1;
        mmx=P[0];
        for (int i=1;i<=okno1-1;i++)
        {
            if (mmx<P[i])
            {
                mmx=P[i];
            }
        }
    obal = mmx*mmx;
    maxima[c2]=obal;
    c2++;
    if (c2==150)    //seřazení pole s maximy od největšího po nejmenší
    {
        c2=149;     //nová hodnota se bude zapisovat na konec pole
        qsort(maxima,150,sizeof(float),compare);    //řadící funkce
    }
    
   for (int i=0;i<=okno1-2;i++)     //smyčka pro posun hodnot v poli o 1 doleva, nová hodnota z ADC se pak zapíše na konec
    {
        P[i]=P[i+1];
    }
    }
     wait(0.001f);
}


for (int i=0;i<150;i++)     //pole už obsahuje jenom 150 maxim z celého měření v předchozí smyčce
{
    prah=prah+maxima[i];
}
    prah=(prah/150)*0.4;    //výsledný práh jako 40% z maxim

c1=0;
f=0;
f1=0;
c2=0;
c3=0; 
c4=0;
k=0;
//přečtení a vyfiltrování jednoho vzorku z termistoru
samples1[0] = ain1.read_u16();      
nProcessedSamples = filter2_filterBlock( filter2, samples1, outputBuffer1, inputBufferSize );
   
    if (outputBuffer1[0]>0)     //nastavení flagu podle toho jestli je dehová křivka v kladné nebo v záporné půlvlnně
    {
        ff1=1;
    }
    else 
    {
        ff1=0;
    }

   t.start();   //spuštění timeru

   led=1;
   led1=0;
//Smyčka pro určení normálních hodnot tepu a dechové frekvence
while (1)
{ 
    samples[0] = ain.read_u16();
    nProcessedSamples = filter1_filterBlock( filter, samples, outputBuffer, inputBufferSize );
    P[c1]=outputBuffer[0];
    c1++;
    if (c1==okno1 || f==1)
    {
        f=1;
        c1=okno1-1;
        mmx=P[0];
        for (int i=1;i<=okno1-1;i++)
        {
            if (mmx<P[i])
            {
                mmx=P[i];
            }
        }
    obal = mmx*mmx;
    if (obal>prah && f1==0 && c5==0)    //první překročení prahu
    {
        f1=1;
        cas1=t.read();
        led=0;
        nprh=obal;
    }
    if(f1==1 && nprh<obal)      //do nprh se uloží maximální hodnota z obálky nad prahovou hodnotou
    {
        nprh=obal;    
    }
    if (obal<prah && f1==1)     //obálku už není nad prahem
    {
      f1=0;
      cas2=t.read();
      led=1;
      cas[c2]=(cas1+cas2)/2;    //střední hodnota mezi časy překročení prahových hodnot
      c2++;
      prah=nprh*0.4;    //práh je adaptivní, upravuje se podle poslední zaznamenané maximální hodnoty
      c5=50;    //nastavení aby 50 ms nemohla být detekována další R vlna
    }
    if (c2==2)
    {
        c2=1;
        RRu=cas[1]-cas[0];
        cas[0]=cas[1];
        RRu=60/RRu;     //aktuální tepová frekvence
        NormalBPM=NormalBPM+(RRu/100);   //výpočet pro výslednou tepovou frekvenci
        c3++;
    }
    }
    if (c5>0)   //delay pro detekci další R vlny
    {
     c5--;
    }
    
//začátek výpočtů pro dechovou křivku
    if (k%100==0)    //provede se jednou za 100 cyklů, tedy jednou za 100 ms
{
   samples1[0] = ain1.read_u16();
   nProcessedSamples = filter2_filterBlock( filter2, samples1, outputBuffer1, inputBufferSize );
   filtvzor = outputBuffer1[0];
//časy průchodu nulou se zaznamenají vždy jak přechází z kladné do záporné půlvlny
   if (filtvzor>0 && ff1==0)    
   {    
    if(ff2==1)
    {
        ccas2=t.read();
        ff2=0;
        ccas=60/(ccas2-ccas1);  //aktuální dechová frekvence
        Normaldech=Normaldech+ccas;
        c4++;   //počet zaznamenaných hodnot
    }  
       ff1=1;
       led3=1;
       ccas1=t.read();
       ff2=1;
   }
    if (filtvzor<0 && ff1==1)
    {   
        ff1=0;
        led3=0;
    }
}
     
//načtení 100 tepů, zprůměrování dechové frekvence a ukončení smyčky     
     if (c3==100)    
     {
         Normaldech=Normaldech/c4;
         break;
     }
    wait(0.001f);
    k++;
}

led1=1;
    

    
c1=0;
f=0;
f1=0;
c2=0;
c3=0; 
c4=0;
k=0;
c5=0;
 //výpis normálních hodnot
pc.printf("NormalBPM: %f \r\n",NormalBPM) ;
pc.printf("Normaldech: %f \r\n",Normaldech) ;

//nekonečná smyčka vyhodnocující aktuální tep, dechovou frekvence a rozdíl od normálu  
while (1)
{  
        
    samples[0] = ain.read_u16();
    nProcessedSamples = filter1_filterBlock( filter, samples, outputBuffer, inputBufferSize );
    P[c1]=outputBuffer[0];
    c1++;
    if (c1==okno1 || f==1)
    {
        f=1;
        c1=okno1-1;
        mmx=P[0];
        for (int i=1;i<=okno1-1;i++)
        {
            if (mmx<P[i])
            {
                mmx=P[i];
            }
        }
    obal = mmx*mmx;    
    if (obal>prah && f1==0 && c5==0)
    {
        f1=1;
        cas1=t.read();
        led=0;
        nprh=obal;
    }
    if(f1==1 && nprh<obal)
    {
        nprh=obal;    
    }
    if (obal<prah && f1==1)
    {
      f1=0;
      cas2=t.read();
      led=1;
      cas[c2]=(cas1+cas2)/2;
      c2++;
      prah=nprh*0.4;
      c5=50;
    }
    if (c2==2)
    {
        c2=1;
        RR[c3]=cas[1]-cas[0];
        cas[0]=cas[1];
        RR[c3]=60/RR[c3];   //průměrování ze tří posledních hodnot tepu
        c3++;
        if (c3==3)
        {
            BPM=(RR[0]+RR[1]+RR[2])/3;
            c3=2;
            RR[0]=RR[1];
            RR[1]=RR[2];
            //pc.printf ("BPM: %f\r\n",BPM);   //možnost nechat si vypsat aktuální tep
            if (BPM>NormalBPM+8)    //pokud aktuální tep překročí normál o 8, tak se vypíše, že došlo k překročení a o kolik
            {
            pc.printf("Tep vyssi o %.2f BPM\r\n",BPM-NormalBPM);
            }
        }
            
       
    }
    }
    if (c5>0)
    {
        c5--;
    }
    
//hodnocení dechové frekvence
     if (k%100==0)
     {
     samples1[0] = ain1.read_u16();
     nProcessedSamples = filter2_filterBlock( filter2, samples1, outputBuffer1, inputBufferSize );
     filtvzor = outputBuffer1[0];
     
    if (filtvzor>0 && ff1==0)
    {    
    if(ff2==1)
    {
        ccas2=t.read();
        ff2=0;
        ccas=60/(ccas2-ccas1);
        //pc.printf("Frekvence dechu: %f",ccas);    //možnost nechat si vypsat aktuální dechovou frekvenci
        if (ccas>Normaldech+5)  //pokud dojde k překročení dechové frekvence o 5, tak se vypíše, že došlo k překročení a o kolik
        {
        pc.printf("Dech vyssi o %.2f za minutu\r\n",ccas-Normaldech);
        }
    }  
       ff1=1;
       led3=1;
       ccas1=t.read();
       ff2=1;
    }
    if (filtvzor<0 && ff1==1)
    {   ff1=0;
   
        led3=0;
        }
     }
    wait(0.001f);
    k++;
}
    
    
}

int compare (const void * a, const void * b)
{
  return ( *(int*)b - *(int*)a );
}


filter1Type *filter1_create( void )
{
    filter1Type *result = (filter1Type *)malloc( sizeof( filter1Type ) );   // Allocate memory for the object
    filter1_init( result );                                         // Initialize it
    return result;                                                              // Return the result
}

void filter1_destroy( filter1Type *pObject )
{
    free( pObject );
}

 void filter1_init( filter1Type * pThis )
{
    filter1_reset( pThis );

}

 void filter1_reset( filter1Type * pThis )
{
    memset( &pThis->state, 0, sizeof( pThis->state ) ); // Reset state to 0
    pThis->output = 0;                                  // Reset output

}

 int filter1_filterBlock( filter1Type * pThis, float * pInput, float * pOutput, unsigned int count )
{
    filter1_executionState executionState;          // The executionState structure holds call data, minimizing stack reads and writes 
    if( ! count ) return 0;                         // If there are no input samples, return immediately
    executionState.pInput = pInput;                 // Pointers to the input and output buffers that each call to filterBiquad() will use
    executionState.pOutput = pOutput;               // - pInput and pOutput can be equal, allowing reuse of the same memory.
    executionState.count = count;                   // The number of samples to be processed
    executionState.pState = pThis->state;                   // Pointer to the biquad's internal state and coefficients. 
    executionState.pCoefficients = filter1_coefficients;    // Each call to filterBiquad() will advance pState and pCoefficients to the next biquad

    // The 1st call to filter1_filterBiquad() reads from the caller supplied input buffer and writes to the output buffer.
    // The remaining calls to filterBiquad() recycle the same output buffer, so that multiple intermediate buffers are not required.

    filter1_filterBiquad( &executionState );        // Run biquad #0
    executionState.pInput = executionState.pOutput;         // The remaining biquads will now re-use the same output buffer.

    filter1_filterBiquad( &executionState );        // Run biquad #1

    filter1_filterBiquad( &executionState );        // Run biquad #2

    filter1_filterBiquad( &executionState );        // Run biquad #3

    // At this point, the caller-supplied output buffer will contain the filtered samples and the input buffer will contain the unmodified input samples.  
    return count;       // Return the number of samples processed, the same as the number of input samples

}

 void filter1_filterBiquad( filter1_executionState * pExecState )
{
    // Read state variables
    float w0, x0;
    float w1 = pExecState->pState[0];
    float w2 = pExecState->pState[1];

    // Read coefficients into work registers
    float b0 = *(pExecState->pCoefficients++);
    float b1 = *(pExecState->pCoefficients++);
    float b2 = *(pExecState->pCoefficients++);
    float a1 = *(pExecState->pCoefficients++);
    float a2 = *(pExecState->pCoefficients++);

    // Read source and target pointers
    float *pInput  = pExecState->pInput;
    float *pOutput = pExecState->pOutput;
    short count = pExecState->count;
    float accumulator;

    // Loop for all samples in the input buffer
    while( count-- )
    {
        // Read input sample
        x0 = *(pInput++);
    
        // Run feedback part of filter
        accumulator  = w2 * a2;
        accumulator += w1 * a1;
        accumulator += x0 ;

        w0 = accumulator ;
    
        // Run feedforward part of filter
        accumulator  = w0 * b0;
        accumulator += w1 * b1;
        accumulator += w2 * b2;

        w2 = w1;        // Shuffle history buffer
        w1 = w0;

        // Write output
        *(pOutput++) = accumulator ;
    }

    // Write state variables
    *(pExecState->pState++) = w1;
    *(pExecState->pState++) = w2;

}

filter2Type *filter2_create( void )
{
    filter2Type *result = (filter2Type *)malloc( sizeof( filter2Type ) );   // Allocate memory for the object
    filter2_init( result );                                         // Initialize it
    return result;                                                              // Return the result
}

void filter2_destroy( filter2Type *pObject )
{
    free( pObject );
}

 void filter2_init( filter2Type * pThis )
{
    filter2_reset( pThis );

}

 void filter2_reset( filter2Type * pThis )
{
    memset( &pThis->state, 0, sizeof( pThis->state ) ); // Reset state to 0
    pThis->output = 0;                                  // Reset output

}

 int filter2_filterBlock( filter2Type * pThis, float * pInput, float * pOutput, unsigned int count )
{
    filter2_executionState executionState;          // The executionState structure holds call data, minimizing stack reads and writes 
    if( ! count ) return 0;                         // If there are no input samples, return immediately
    executionState.pInput = pInput;                 // Pointers to the input and output buffers that each call to filterBiquad() will use
    executionState.pOutput = pOutput;               // - pInput and pOutput can be equal, allowing reuse of the same memory.
    executionState.count = count;                   // The number of samples to be processed
    executionState.pState = pThis->state;                   // Pointer to the biquad's internal state and coefficients. 
    executionState.pCoefficients = filter2_coefficients;    // Each call to filterBiquad() will advance pState and pCoefficients to the next biquad

    // The 1st call to filter2_filterBiquad() reads from the caller supplied input buffer and writes to the output buffer.
    // The remaining calls to filterBiquad() recycle the same output buffer, so that multiple intermediate buffers are not required.

    filter2_filterBiquad( &executionState );        // Run biquad #0
    executionState.pInput = executionState.pOutput;         // The remaining biquads will now re-use the same output buffer.

    filter2_filterBiquad( &executionState );        // Run biquad #1

    filter2_filterBiquad( &executionState );        // Run biquad #2

    filter2_filterBiquad( &executionState );        // Run biquad #3

    // At this point, the caller-supplied output buffer will contain the filtered samples and the input buffer will contain the unmodified input samples.  
    return count;       // Return the number of samples processed, the same as the number of input samples

}

 void filter2_filterBiquad( filter2_executionState * pExecState )
{
    // Read state variables
    float w0, x0;
    float w1 = pExecState->pState[0];
    float w2 = pExecState->pState[1];

    // Read coefficients into work registers
    float b0 = *(pExecState->pCoefficients++);
    float b1 = *(pExecState->pCoefficients++);
    float b2 = *(pExecState->pCoefficients++);
    float a1 = *(pExecState->pCoefficients++);
    float a2 = *(pExecState->pCoefficients++);

    // Read source and target pointers
    float *pInput  = pExecState->pInput;
    float *pOutput = pExecState->pOutput;
    short count = pExecState->count;
    float accumulator;

    // Loop for all samples in the input buffer
    while( count-- )
    {
        // Read input sample
        x0 = *(pInput++);
    
        // Run feedback part of filter
        accumulator  = w2 * a2;
        accumulator += w1 * a1;
        accumulator += x0 ;

        w0 = accumulator ;
    
        // Run feedforward part of filter
        accumulator  = w0 * b0;
        accumulator += w1 * b1;
        accumulator += w2 * b2;

        w2 = w1;        // Shuffle history buffer
        w1 = w0;

        // Write output
        *(pOutput++) = accumulator ;
    }

    // Write state variables
    *(pExecState->pState++) = w1;
    *(pExecState->pState++) = w2;

}


